(* tests on biegelinie
   author: Walther Neuper 050826
   (c) due to copyright terms

use"../smltest/IsacKnowledge/biegelinie.sml";
use"biegelinie.sml";
*)
val thy = Biegelinie.thy;

"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- the rules -------------------------------------------";
"----------- Script [IntegrierenUndKonstanteBestimmen] -----------";
"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
"----------- simplify_leaf for this script -----------------------";
"----------- Bsp 7.27 me -----------------------------------------";
"----------- Bsp 7.27 autoCalculate ------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";


"----------- the rules -------------------------------------------";
"----------- the rules -------------------------------------------";
"----------- the rules -------------------------------------------";
fun str2t str = (term_of o the o (parse Biegelinie.thy)) str;
fun term2s t = Sign.string_of_term (sign_of Biegelinie.thy) t;
fun rewrit thm str = 
    fst (the (rewrite_ Biegelinie.thy tless_true e_rls true thm str));

val t = rewrit Belastung_Querkraft (str2t "- q x = - q_0"); term2s t;
if term2s t = "Q' x = - q_0" then ()
else raise error  "/biegelinie.sml: Belastung_Querkraft";

val t = rewrit Querkraft_Moment (str2t "Q x = - q_0 * x + c"); term2s t;
if term2s t = "M_b' x = - q_0 * x + c" then ()
else raise error  "/biegelinie.sml: Querkraft_Moment";

val t = rewrit Moment_Neigung (str2t "M_b x = -q_0 * x^^^2/2 + q_0/2 *L*x");
    term2s t;
if term2s t = "- EI * y'' x = - q_0 * x ^^^ 2 / 2 + q_0 / 2 * L * x" then ()
else raise error  "biegelinie.sml: Moment_Neigung";


"----------- Script [IntegrierenUndKonstanteBestimmen] -----------";
"----------- Script [IntegrierenUndKonstanteBestimmen] -----------";
"----------- Script [IntegrierenUndKonstanteBestimmen] -----------";
val str =
"Script BiegelinieScript                                                  \
\(l_::real) (q_::real) (v_::real) (b_::real=>real)                        \
\(rb_::bool list) (rm_::bool list) =                                      \
\  (let q__ = Take (q v_ = q_);                                           \
\       q__ = ((Rewrite sym_real_minus_eq_cancel True) @@                 \
\              (Rewrite Belastung_Querkraft True)) q__;                   \
\      (Q__:: bool) =                                                     \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs q__), real_ v_, real_real_ Q]);    \
\       Q__ = Rewrite Querkraft_Moment True Q__;                          \
\      (M__::bool) =                                                      \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs Q__), real_ v_, real_real_ M_b]);  \
\       e1__ = nth_ 1 rm_;                                                \
\      (x1__::real) = argument_in (lhs e1__);                             \
\      (M1__::bool) = (Substitute [v_ = x1__]) M__;                       \
\       M1__        = (Substitute [e1__]) M1__ ;                          \
\       M2__ = Take M__;                                                  "^
(*without this Take 'Substitute [v_ = x2__]' takes _last formula from ctree_*)
"       e2__ = nth_ 2 rm_;                                                \
\      (x2__::real) = argument_in (lhs e2__);                             \
\      (M2__::bool) = ((Substitute [v_ = x2__]) @@                        \
\                      (Substitute [e2__])) M2__;                         \
\      (c_1_2__::bool list) =                                             \
\             (SubProblem (Biegelinie_,[linear,system],[no_met])          \
\                          [booll_ [M1__, M2__], reall [c,c_2]]);         \
\       M__ = Take  M__;                                                  \
\       M__ = ((Substitute c_1_2__) @@                                    \
\              (Try (Rewrite_Set_Inst [(bdv_1, c),(bdv_2, c_2)]\
\                                   simplify_System False)) @@ \
\              (Rewrite Moment_Neigung False) @@ \
\              (Rewrite make_fun_explicit False)) M__;                    "^
(*----------------------- and the same once more ------------------------*)
"      (N__:: bool) =                                                     \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs M__), real_ v_, real_real_ y']);   \
\      (B__:: bool) =                                                     \
\             (SubProblem (Biegelinie_,[named,integrate,function],        \
\                          [Diff,integration,named])                      \
\                          [real_ (rhs N__), real_ v_, real_real_ y]);    \
\       e1__ = nth_ 1 rb_;                                                \
\      (x1__::real) = argument_in (lhs e1__);                             \
\      (B1__::bool) = (Substitute [v_ = x1__]) B__;                       \
\       B1__        = (Substitute [e1__]) B1__ ;                          \
\       B2__ = Take B__;                                                  \
\       e2__ = nth_ 2 rb_;                                                \
\      (x2__::real) = argument_in (lhs e2__);                             \
\      (B2__::bool) = ((Substitute [v_ = x2__]) @@                        \
\                      (Substitute [e2__])) B2__;                         \
\      (c_1_2__::bool list) =                                             \
\             (SubProblem (Biegelinie_,[linear,system],[no_met])          \
\                          [booll_ [B1__, B2__], reall [c,c_2]]);         \
\       B__ = Take  B__;                                                  \
\       B__ = ((Substitute c_1_2__) @@                                    \
\              (Rewrite_Set_Inst [(bdv, x)] make_ratpoly_in False)) B__   \
\ in B__)"
;
val sc = ((inst_abs thy) o term_of o the o (parse thy)) str;
(*---^^^-OK-----------------------------------------------------------------*)
(*---vvv-NOTok--------------------------------------------------------------*)
atomty sc;
atomt sc;

(* use"../smltest/IsacKnowledge/biegelinie.sml";
   *)


"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
"----------- IntegrierenUndKonstanteBestimmen by rewriting -------";
val t = str2t "M_b x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2";
val t = rewrit Moment_Neigung t; term2s t;
(*was "EI * ?y'' x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2"
           ### before declaring "y''" as a constant *)
val t = rewrit make_fun_explicit t; term2s t;

(* use"../smltest/IsacKnowledge/biegelinie.sml";
   *)


"----------- simplify_leaf for this script -----------------------";
"----------- simplify_leaf for this script -----------------------";
"----------- simplify_leaf for this script -----------------------";
val rm_ = str2term"[M_b 0 = 0, M_b L = 0]";
val M__ = str2term"M_b x = -1 * x ^^^ 2 / 2 + x * c + c_2";
val Some (e1__,_) = 
    rewrite_set_ thy false srls 
		 (str2term"(nth_::[real,bool list]=>bool) 1 " $ rm_);
if term2str e1__ = "M_b 0 = 0" then ()
else raise error "biegelinie.sml simplify nth_ 1 rm_";

val Some (x1__,_) = 
    rewrite_set_ thy false srls 
		 (str2term"argument_in (lhs (M_b 0 = 0))");
if term2str x1__ = "0" then ()
else raise error "biegelinie.sml simplify argument_in (lhs (M_b 0 = 0)";

trace_rewrite:=true;
trace_rewrite:=false;



"----------- Bsp 7.27 me -----------------------------------------";
"----------- Bsp 7.27 me -----------------------------------------";
"----------- Bsp 7.27 me -----------------------------------------";
val fmz = ["Traegerlaenge L","Streckenlast q_0","Biegelinie y",
	   "RandbedingungenBiegung [y 0 = 0, y L = 0]",
	   "RandbedingungenMoment [M_b 0 = 0, M_b L = 0]",
	   "FunktionsVariable x"];
val (dI',pI',mI') =
  ("Biegelinie.thy",["MomentBestimmte","Biegelinien"],
   ["IntegrierenUndKonstanteBestimmen"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;

val pits = get_obj g_pbl pt (fst p);writeln (itms2str thy pits);
(*if itms2str thy pits = ... all 5 model-items*)
val mits = get_obj g_met pt (fst p); writeln (itms2str thy mits);
if itms2str thy mits = "[]" then ()
else raise error  "biegelinie.sml: Bsp 7.27 #2";

val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_,Add_Given "FunktionsVariable x") => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #4a";
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val mits = get_obj g_met pt (fst p);writeln (itms2str thy mits);
(*if itms2str thy mits = ... all 6 guard-items*)
case nxt of (_, Apply_Method ["IntegrierenUndKonstanteBestimmen"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #4b";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case pt of Nd (PblObj _, [Nd _]) => ((*Apply_Method + Take*))
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #4c";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;

case nxt of 
    (_,Subproblem ("Biegelinie.thy", ["named", "integrate", "function"])) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #4c";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Diff", "integration", "named"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #5";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of 
    ("Check_Postcond", Check_Postcond ["named", "integrate", "function"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #5a";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of 
    (_, Subproblem ("Biegelinie.thy", ["named", "integrate", "function"]))=>()
  | _ => raise error "biegelinie.sml: Bsp 7.27 #5b";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Diff", "integration","named"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #6";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt(*nxt = Check_Postcond ["named", "int..*);
f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of (_, Substitute ["x = 0"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #7";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "0 = c_2 + c * 0 + -1 * q_0 / 2 * 0 ^^^ 2" then ()
else raise error  "biegelinie.sml: Bsp 7.27 #8";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "0 = c_2 + c * L + -1 * q_0 / 2 * L ^^^ 2" then ()
else raise error  "biegelinie.sml: Bsp 7.27 #9";

(*val nxt = (+, Subproblem ("Biegelinie.thy", ["normalize", ..lin..sys]))*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["EqSystem", "normalize", "2x2"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #10";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
(*val nxt = Subproblem ["triangular", "2x2", "linear", "system"]*)
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method["EqSystem", "top_down_substitution", "2x2"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #11";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of (_, Check_Postcond ["normalize", "2x2", "linear", "system"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #12";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of
    (_, Subproblem ("Biegelinie.thy", ["named", "integrate", "function"]))=>()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #13";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Diff", "integration", "named"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #14";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of
    (_, Check_Postcond ["named", "integrate", "function"]) => ()
  | _ => raise error  "biegelinie.sml: Bsp 7.27 #15";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f =
  "y' x = c + 1 / (-1 * EI) * (L * q_0 / 4 * x ^^^ 2 + -1 * q_0 / 6 * x ^^^ 3)"
then () else raise error  "biegelinie.sml: Bsp 7.27 #16 f";
case nxt of
    (_, Subproblem ("Biegelinie.thy", ["named", "integrate", "function"]))=>()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #16";

val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["Diff", "integration", "named"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #17";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = 
   "y x =\nc_2 + c * x +\n\
   \1 / (-1 * EI) * (L * q_0 / 12 * x ^^^ 3 + -1 * q_0 / 24 * x ^^^ 4)"
then () else raise error  "biegelinie.sml: Bsp 7.27 #18 f";
case nxt of
    (_, Check_Postcond ["named", "integrate", "function"]) => ()
  | _ => raise error  "biegelinie.sml: Bsp 7.27 #18";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of
    (_, Subproblem
            ("Biegelinie.thy", ["normalize", "2x2", "linear", "system"])) => ()
  | _ => raise error  "biegelinie.sml: Bsp 7.27 #19";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method ["EqSystem", "normalize", "2x2"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #20";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "[c_2 = 0, L * c + c_2 = -1 * q_0 * L ^^^ 4 / (-24 * EI)]" then ()
else raise error  "biegelinie.sml: Bsp 7.27 #21 f";
case nxt of
    (_, Subproblem
            ("Biegelinie.thy", ["triangular", "2x2", "linear", "system"])) =>()
  | _ => raise error  "biegelinie.sml: Bsp 7.27 #21";
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
case nxt of (_, Apply_Method["EqSystem", "top_down_substitution", "2x2"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #22";
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
case nxt of (_, Check_Postcond ["normalize", "2x2", "linear", "system"]) => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #23";

val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
if f2str f = "y x =\n-1 * q_0 * L ^^^ 4 / (-24 * EI * L) * x +\n\
	     \(2 * L * q_0 / (-24 * EI) * x ^^^ 3 + \
	     \-1 * q_0 / (-24 * EI) * x ^^^ 4)" then ()
else raise error  "biegelinie.sml: Bsp 7.27 #24 f";
case nxt of ("End_Proof'", End_Proof') => ()
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 #24";

(* use"../smltest/IsacKnowledge/biegelinie.sml";
   *)
show_pt pt;
(*(([], Frm), Problem (Biegelinie.thy, [MomentBestimmte, Biegelinien])),
(([1], Frm), q x = q_0),
(([1], Res), - q x = - q_0),
(([2], Res), Q' x = - q_0),
(([3], Pbl), Integrate (- q_0, x)),
(([3,1], Frm), Q x = Integral - q_0 D x),
(([3,1], Res), Q x = -1 * q_0 * x + c),
(([3], Res), Q x = -1 * q_0 * x + c),
(([4], Res), M_b' x = -1 * q_0 * x + c),
(([5], Pbl), Integrate (-1 * q_0 * x + c, x)),
(([5,1], Frm), M_b x = Integral -1 * q_0 * x + c D x),
(([5,1], Res), M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * c + c_2),
(([5], Res), M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * c + c_2),
(([6], Res), M_b 0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2),
(([7], Res), 0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2),
(([8], Res), M_b L = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2),
(([9], Res), 0 = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2),
(([10], Pbl), solveSystem [0 = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2] [c_2]),
(([10,1], Frm), [0 = -1 * q_0 * 0 ^^^ 2 / 2 + 0 * c + c_2,
 0 = -1 * q_0 * L ^^^ 2 / 2 + L * c + c_2]),
(([10,1], Res), [0 = c_2, 0 = -1 * (q_0 * L ^^^ 2) / 2 + (L * c + c_2)]),
(([10,2], Res), [c_2 = 0, L * c + c_2 = 0 + -1 * (-1 * (q_0 * L ^^^ 2) / 2)]),
(([10,3], Res), [c_2 = 0, L * c + c_2 = q_0 * L ^^^ 2 / 2]),
(([10,4], Pbl), solveSystem [L * c + c_2 = q_0 * L ^^^ 2 / 2] [c_2]),
(([10,4,1], Frm), L * c + c_2 = q_0 * L ^^^ 2 / 2),
(([10,4,1], Res), L * c + 0 = q_0 * L ^^^ 2 / 2),
(([10,4,2], Res), L * c = q_0 * L ^^^ 2 / 2),
(([10,4,3], Res), c = q_0 * L ^^^ 2 / 2 / L),
(([10,4,4], Res), c = L * q_0 / 2),
(([10,4,5], Res), [c = L * q_0 / 2, c_2 = 0]),
(([10,4], Res), [c = L * q_0 / 2, c_2 = 0]),
(([10], Res), [c = L * q_0 / 2, c_2 = 0]),
(([11], Res), M_b x = -1 * q_0 * x ^^^ 2 / 2 + x * (L * q_0 / 2) + 0),
(([12], Res), M_b x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2),
(([13], Res), EI * y'' x = L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2),
(([14], Res), y'' x = 1 / EI * (L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2)),
(([15], Pbl), Integrate (1 / EI * (L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2), x)),
(([15,1], Frm), y' x = Integral 1 / EI * (L * q_0 * x / 2 + -1 * q_0 * x ^^^ 2 / 2) D x),
(([15,1], Res), y' x =
(Integral L * q_0 * x / 2 D x + Integral -1 * q_0 * x ^^^ 2 / 2 D x) / EI +
c)]*)

"----------- Bsp 7.27 autoCalculate ------------------------------";
"----------- Bsp 7.27 autoCalculate ------------------------------";
"----------- Bsp 7.27 autoCalculate ------------------------------";
 states:=[];
 CalcTree [(["Traegerlaenge L","Streckenlast q_0","Biegelinie y",
	     "RandbedingungenBiegung [y 0 = 0, y L = 0]",
	     "RandbedingungenMoment [M_b 0 = 0, M_b L = 0]",
	     "FunktionsVariable x"],
	    ("Biegelinie.thy",
	     ["MomentBestimmte","Biegelinien"],
	     ["IntegrierenUndKonstanteBestimmen"]))];
 moveActiveRoot 1;
 autoCalculate 1 CompleteCalcHead; 

 fetchProposedTactic 1 (*->"Apply_Method" IntegrierenUndKonstanteBestimmen*);
(*
> val (_,Apply_Method' (_, None, ScrState is), _)::_ = tacis;
> is = e_scrstate;
val it = true : bool
*)
 autoCalculate 1 (Step 1) (*->GENERATED ([1], Frm)*);
 val ((pt,_),_) = get_calc 1;
 case pt of Nd (PblObj _, [Nd _]) => ((*Apply_Method + Take*))
	  | _ => raise error  "biegelinie.sml: Bsp 7.27 autoCalculate#4c";

 autoCalculate 1 CompleteCalc;  
 val (unc, del, gen) = (([],Pbl), ([],Pbl), ([],Res));
 getFormulaeFromTo 1 unc gen 1 (*only level 1*) false;

 val ((pt,_),_) = get_calc 1;
 show_pt pt;

(*check all formulae for getTactic*)
 getTactic 1 ([1],Frm) (*see smltest/../reverse-rew.sml*);
 getTactic 1 ([5],Res) (*tac2xml: not impl. for Substitute ["x = 0"]*);
 getTactic 1 ([6],Res) (* ---"---                      ["M_b 0 = 0"]*);
 getTactic 1 ([7],Res) (*!!!!!Take!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*);
 getTactic 1 ([8],Frm) (*tac2xml: not impl. for Substitute ["x = L"]*);
 getTactic 1 ([8],Res) (* ---"---                      ["M_b L = 0"]*);
